/** @file basic.h
 *  @brief グローバル宣言
 */

#ifndef __basic_h__
#define __basic_h__

#include "Arduino.h"
#include "ttconfig.h"
#include "device.h"
#include "workmemdef.h"

#define MYSIGN      "TBU7"    // EPPROM識別用シグニチャ

// キーワード定義マクロ(k:キーワード用変数名 、s:キーワード文字列)
//#define KW(k,s) const char k[] PROGMEM=s  

// **** GPIOピンに関する定義 ***********************
// ピン数の定義
#ifdef ARDUINO_AVR_MEGA2560
 #define TT_MAX_PINNUM 69
#else
 #define TT_MAX_PINNUM 21
#endif 

//*** インタプリタ用グローバル変数外部参照宣言 ******
extern uint8_t err;                  // エラーコード
extern int16_t errorLine;            // 直前のエラー発生行番号
extern int16_t arr[SIZE_ARRY];       // 配列変数領域
extern int16_t var[26];              // 変数領域（A-Z×2バイト)
extern uint8_t lbuf[SIZE_LINE];      // コマンドラインバッファ
extern uint8_t listbuf[SIZE_LIST];   // プログラム領域
extern uint8_t* cip;                 // インタプリタ中間コード参照位置
extern uint8_t* clp;                 // カレント行先頭ポインタ
extern uint8_t prevPressKey;         // 直前入力キーの値(INKEY()、[ESC]中断キー競合防止用)
extern uint8_t val_if;              // if文判定結果
extern uint8_t* gstk[SIZE_GSTK];    //!< GOSUB スタック
extern uint8_t gstki;               // GOSUB スタック インデックス
extern uint8_t lstki;               // FOR 市タック インデックスtoktoi()
extern uint8_t ibuf[SIZE_IBUF];     //!< 中間コード変換バッファ

//*** 関数のプロトタイプ宣言 **********************

// 出力制御他版との互換用
//uint8_t c_getch();
#define c_kbhit() (Serial.available()?c_getch():0)
#define c_getHeight()  24
#define c_getWidth()   80
#define c_IsCurs()     flgCurs

#endif
