/**
 * @file charlib.cpp
 * @brief 文字関係のライブラリ
 */

#include <stdint.h>
#include "charlib.h"

//*************
//* 文字処理 ***
//*************

// 英小文字⇒大文字変換
char c_toupper(char c) { return(c <= 'z' && c >= 'a' ? c - 32 : c); }
// 表示可能文字チェック
char c_isprint(char c) { return (c); }
// 空白文字(スペース、制御文字)
char c_isspace(char c) { return(c == ' ' || (c <= 13 && c >= 9)); }
// 数値チェック
char c_isdigit(char c) { return(c <= '9' && c >= '0'); }
// 英字チェック
char c_isalpha(char c) { return ((c <= 'z' && c >= 'a') || (c <= 'Z' && c >= 'A')); }
// 全角判定
uint8_t isZenkaku(uint8_t c){
  return (((c>=0x81)&&(c<=0x9f))||((c>=0xe0)&&(c<=0xfc))) ? 1:0;
}

uint16_t hex2value(char c) {
  if (c <= '9' && c >= '0')
    c -= '0';
  else if (c <= 'f' && c >= 'a')
    c = c + 10 - 'a';
  else if (c <= 'F' && c >= 'A')
    c = c + 10 - 'A' ;
  return c;
}
