
/**
 * @file console.h
 * @brief コンソール関係（スクリーン制御、ラインエディタ等)のヘッダー
 */

#ifndef __console_h__
#define __console_h__

#include <stdint.h>
#include "device.h"

void init_console();
uint8_t* getlp(short lineno);
int16_t getlineno(uint8_t *lp);

void icls();
void ilocate();
void icolor() ;
void iattr() ;
void c_show_curs(uint8_t mode);
uint8_t isBreak();

void iprint(uint8_t devno, uint8_t nonewln);

int16_t getPrevLineNo(int16_t lineno);
int16_t getNextLineNo(int16_t lineno);
void line_delCharAt(uint8_t* str, uint8_t pos);
void line_insCharAt(uint8_t* str, uint8_t pos,uint8_t c);
//void line_movePrevChar(uint8_t* str, uint8_t ln, uint8_t& pos);
//void line_moveNextChar(uint8_t* str, uint8_t ln, uint8_t& pos);
void line_redrawLine(uint8_t ln,uint8_t pos,uint8_t len);
void c_gets();

void clearlbuf() ;

void mem_putch(uint8_t c);
//void newline(uint8_t devno=CDEV_SCREEN);
void newline(void);
void newline_dev(uint8_t devno);

void putlist(uint8_t* ip, uint8_t devno ) ;
#endif
