/**
 * @file errcode.h
 * @brief エラーコード定義
 */

#ifndef __errcode_h__
#define __errcode_h__

//*** エラーコード定義 ****************************
// ※並び位置はエラーメッセージ定義と一致させることに注意
// ※エラーメッセージ定義はbasic.cppで定義
enum {
  ERR_OK,
  ERR_DIVBY0,
  ERR_VOF,
  ERR_SOR,
  ERR_IBUFOF, ERR_LBUFOF,
  ERR_GSTKOF, ERR_GSTKUF,
  ERR_LSTKOF, ERR_LSTKUF,
  ERR_NEXTWOV, ERR_NEXTUM, ERR_FORWOV, ERR_FORWOTO,
  ERR_LETWOV, ERR_IFWOC,
  ERR_ULN,
  ERR_PAREN, ERR_VWOEQ,
  ERR_COM,
  ERR_SYNTAX,
  ERR_SYS,
  ERR_CTR_C,
  ERR_VALUE,
  ERR_GPIO,
#if USE_CMD_PLAY == 1 || USE_ALL_KEYWORD == 1
  ERR_PLAY_MML,
#endif
  ERR_I2CDEV,
  ERR_FNAME,
  ERR_NOFSPACE,
#if USE_EVENT == 1 || USE_ALL_KEYWORD == 1
  ERR_NOEDEF,
#endif
#if USE_NEOPIXEL == 1 || USE_ALL_KEYWORD == 1
  ERR_NINIT,
#endif
};

#endif
