/**
 * @file files.h
 * @brief EEPROM と内部データフラッシュ処理のヘッダー
 */

#ifndef __files_h__
#define __files_h__

#include <stdint.h>

// ファイルシステム
#define MODE_LOAD 0
#define MODE_SAVE 1
void iLoadSave(uint8_t mode,uint8_t flgskip=0);
uint8_t getFname(uint8_t* fname, uint8_t limit);
void ierase();
void ifiles();

// I2C EPPROMファイルシステム（オプション）機能
int16_t ii2cw(void);
int16_t ii2cr(void);
void iformat(void);
void iefiles(void);
void iedel(void);
void idrive(void);

#endif
