/**
 * @file flash.h
 * @author your name (you@domain.com)
 * @brief 内部フラッシュEEPROMの制御ルーチンのヘッダー
 * @version 0.1
 * @date 2022-02-10
 * 
 * @copyright Copyright (c) 2022
 * 
 */
#ifndef __flash_h__
#define __flash_h__

#ifdef GRADZUKI
  #if PRGAREASIZE <= 1024
    #define EEPROM_PAGE_NUM         4      // 全ページ数
    #define EEPROM_PAGE_SIZE        1024   // ページ内バイト数
    #define EEPROM_SAVE_NUM         4      // プログラム保存可能数
    #define EEPROM_PER_BLOCK        1      // 1ページのブロック数
  #elif PRGAREASIZE <= 2048
    #define EEPROM_PAGE_NUM         2      // 全ページ数
    #define EEPROM_PAGE_SIZE        2048   // ページ内バイト数
    #define EEPROM_SAVE_NUM         2      // プログラム保存可能数
    #define EEPROM_PER_BLOCK        2      // 1ページのブロック数
  #elif PRGAREASIZE <= 4096
    #define EEPROM_PAGE_NUM         1      // 全ページ数
    #define EEPROM_PAGE_SIZE        4096   // ページ内バイト数
    #define EEPROM_SAVE_NUM         1      // プログラム保存可能数
    #define EEPROM_PER_BLOCK        4      // 1ページのブロック数
/* 
  #elif PRGAREASIZE <= 8192
    #define EEPROM_PAGE_NUM         1      // 全ページ数
    #define EEPROM_PAGE_SIZE        8192   // ページ内バイト数
    #define EEPROM_SAVE_NUM         1      // プログラム保存可能数
    #define EEPROM_PER_BLOCK        8      // 1ページのブロック数
 */  #endif
#else
 #error "ボード未定義のためEEPROMの設定ができません in file.cpp"
#endif

#if USE_HS_EEPROM == 1
void eeprom_update_pages(uint8_t* wrBuffa, uint8_t pageNo);
void eeprom_read_pages(uint8_t* buffa, uint8_t pageNo);
void eeprom_read_topline(uint8_t* buffa, uint8_t pageNum);
void eeprom_erase_pages(uint8_t pageNo);
void eeprom_read_block(uint8_t *buffa, uint16_t romAddr, size_t n);
void eeprom_update_block(uint8_t* buffa, uint16_t romAddr, size_t size);
void eeprom_clear_block( uint16_t topAddress) ;

#else
void eeprom_read_block(uint8_t *buffa, uint16_t romAddr, size_t n);
void eeprom_update_block(uint8_t* buffa, uint16_t romAddr, size_t size);
void eeprom_clear_block( uint16_t topAddress) ;
#endif

#endif
