/**
 * @file gpio.h
 * @brief I/O pin 処理のヘッダー
 */
#ifndef __gpio_h__
#define __gpio_h__
#include <stdint.h>

// GPIO
void igpio();
void iout();
int16_t iIN();
int16_t iana();
void ipwm() ;
int16_t ishiftIn();
void ishiftOut();
int16_t ipulseIn();
int16_t iir();
void i2c_init();
int16_t ii2crw(uint8_t mode);
void iled();

// 液晶キャラクタディスプレイ
/* void LCDinit();
void LCDputch(uint8_t c);
void LCDnewline(); */
void illocate() ;
void ilcls();
void ilcons() ;
void ildisp();
void ilcurs();
void ilprint();

// I2C RTC DS3231
void isetDate();
void igetDate();
void igetTime() ;
void idate(uint8_t devno=0);
void idatestr(uint8_t devno=CDEV_SCREEN);

#endif
