/**
 * @file intercode.h
 * @author your name (you@domain.com)
 * @brief 中間コードテーブル
 * @version 0.1
 * @date 2021-11-29
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#ifndef __intercode_h__
#define __intercode_h__
#include "ttconfig.h"  
//*** 中間コード定義 *******************************
// ※並び位置をキーワードテーブルと一致させることに注意
// ※キーワードテーブルは basic.cppに定義
enum {
  I_GOTO, I_GOSUB, I_RETURN, I_END, 
  I_FOR, I_TO, I_STEP, I_NEXT,
  I_IF, I_ELSE, I_REM,
  I_INPUT, I_PRINT, I_QUEST, I_LET,
  I_COMMA, I_SEMI,I_COLON, I_SQUOT,
  I_MINUS, I_PLUS, I_OPEN, I_CLOSE, I_DOLLAR, I_APOST,
  
// 2因子演算子: "*","/","%","<<",">>","&","|","^"
  I_MUL, I_DIV, I_DIVR, I_LSHIFT, I_RSHIFT, I_AND, I_OR, I_XOR,

// 条件判定演算子
  I_EQ, I_NEQ, I_NEQ2,I_LT,I_LTE, I_GT, I_GTE, I_LAND, I_LOR,

  I_SHARP, 
  I_LNOT, I_BITREV, 
  I_ARRAY, I_RND, I_ABS, I_SIZE,

// システムコマンド
  I_RUN, I_LIST, I_RENUM, I_DELETE, I_NEW, 
  I_LOAD, I_SAVE, I_ERASE, I_FILES,
  I_FORMAT, I_DRIVE,
  I_CLS,
#if USE_CMD_VFD == 1 || USE_ALL_KEYWORD == 1
  I_VMSG, I_VCLS, I_VSCROLL, I_VBRIGHT, I_VDISPLAY, I_VPUT,
#endif
  I_WAIT,
  I_CHR,  I_HEX, I_BIN, I_STRREF,
  I_BYTE, I_LEN, I_ASC,
  I_COLOR, I_ATTR, I_LOCATE, I_INKEY,
  I_GPIO, I_DOUT, I_POUT,
  I_DIN, I_ANA,
  I_TONE, I_NOTONE,
#if USE_CMD_PLAY == 1 || USE_ALL_KEYWORD == 1
  I_PLAY, I_TEMPO,
#endif
  I_SYSINFO,

// 仮想アドレス
  I_MVAR, I_MARRAY, I_MPRG, I_MEM, I_MEM2, 
  
  I_PEEK, I_POKE, I_I2CW, I_I2CR, I_TICK,
  I_MAP, I_GRADE, I_SHIFTOUT, I_PULSEIN, I_DMP, I_SHIFTIN,

// 定数    
  I_OUTPUT, I_INPUT_PU, I_INPUT_FL,
  I_OFF, I_ON,  I_LOW, I_HIGH,I_LSB, I_MSB,
  I_KUP, I_KDOWN, I_KRIGHT, I_KLEFT, I_KSPACE, I_KENTER,  // キーボードコード
  I_CW, I_CH,  I_CHANGE, I_FALLING, I_RISING,
  I_LED,

#if USE_RTC_DS3231 == 1 && USE_CMD_I2C == 1 || USE_RL78_RTC == 1 || USE_ALL_KEYWORD == 1
  I_DATE, I_GETDATE, I_GETTIME, I_SETDATE, I_DATESTR,  // RTC関連コマンド(5)  
#endif 
#if USE_SO1602AWWB == 1 && USE_CMD_I2C == 1 || USE_ALL_KEYWORD == 1
  I_CPRINT, I_CCLS, I_CCURS, I_CLOCATE, I_CCONS, I_CDISP,
#endif
#if USE_ANADEF == 1 || USE_ALL_KEYWORD == 1
  I_A0,I_A1,I_A2,I_A3,I_A4,I_A5,I_A6,I_A7,
  #ifdef ARDUINO_AVR_MEGA2560
    I_A8,I_A9,I_A10,I_A11,I_A12,I_A13,I_A14,I_A15,
  #endif  
#endif
#if USE_IR == 1 || USE_ALL_KEYWORD == 1
  I_IR,
#endif
// 美咲フォントの利用
#if USE_MISAKIFONT != 0 || USE_ALL_KEYWORD == 1
  I_GETFONT,
#endif
// NeoPixelの利用
#if USE_NEOPIXEL || USE_ALL_KEYWORD == 1
  I_NINIT, I_NBRIGHT, I_NCLS, I_NSET, I_NPSET, I_NMSG, I_NUPDATE, I_NSHIFT, 
  I_RGB, I_NLINE,I_NSCROLL, I_NPOINT,
#endif
// タイマー・外部割込みイベントの利用
#if USE_EVENT == 1 || USE_ALL_KEYWORD == 1
  I_TIMER, I_PIN, I_SLEEP,
#endif
// キャラクタディスプレイ（LCD 4bit I/F)
#if USE_SC1602BS == 1 || USE_ALL_KEYWORD == 1
  I_LPRINT, I_LCLS, I_LCURS, I_LLOCATE, I_LCONS, I_LDISP,
#endif
  I_OK, 
  I_NUM, I_VAR, I_STR, I_HEXNUM, I_BINNUM,
  I_EOL
};

#endif
